/*

 Simple Image Glitching Processing
 datamoshing.com | 2016
 
 */

// image path is relative to sketch directory
PImage img;
String imgFileName = "MyImage";
String fileType = "jpg";

boolean glitchComplete = false;
boolean glitchSaved = false;

void setup() {
  img = loadImage(imgFileName+"."+fileType);

  // use only numbers (not variables) for the size() command, Processing 3
  size(1, 1);

  // allow resize and update surface to image dimensions
  surface.setResizable(true);
  surface.setSize(img.width, img.height);

  // load image onto surface
  image(img, 0, 0, img.width, img.height);
}


void draw() {
  if (!glitchComplete)
  {
    // load the image's pixels into .pixel array 
    img.loadPixels();

    // for each column of pixels
    for (int x = 0; x < img.width; x++) {

      // for each row of pixels
      for (int y = 0; y < img.height; y++) {
        
          // get the color for the pixel at coordinates x/y
          color pixelColor = img.pixels[y + x * img.height];
      }
    }

    img.updatePixels();
    glitchComplete = true;

    // load updated image onto surface
    image(img, 0, 0, img.width, img.height);

    // apply some filters
    // https://processing.org/reference/filter_.html
    
    // posterize filter
    // filter(POSTERIZE, 4);
    
    // dilate filter
    // filter(DILATE);
  }

  if (glitchComplete && !glitchSaved) {

    // save surface
    img.save(imgFileName+"_glitched.png");
    glitchSaved = true;
    println("Glitched image saved");
    println("Click or press any key to exit...");
  }
}

void keyPressed() {
  if (glitchSaved)
  {
    System.exit(0);
  }
}

void mouseClicked() {
  if (glitchSaved)
  {
    System.exit(0);
  }
}